<template>
  <div>
    <div class="chat-select">
      <v-select
        v-if="picOwnerId === userID"
        :items="chats"
        item-text="name"
        item-value="value"
        label="Select chat"
        v-model="currentChat"
        @change="changeChat"
        outlined
        rounded
        filled
      />
      <v-btn
        v-else-if="!chatID"
        class="dark-btn"
        @click="createChat">
        Create chat
      </v-btn>
    </div>
    <Chat
      v-if="chatID"
      :participants="participants"
      :myself="myself"
      :messages="messages"
      :placeholder="placeholder"
      :colors="colors"
      :hide-close-button="true"
      :submit-icon-size="submitIconSize"
      :submit-image-icon-size="submitImageIconSize"
      :load-more-messages="addMoreMessages"
      :scroll-bottom="scrollBottom"
      :display-header="false"
      :send-images="false"
      :profile-picture-config="profilePictureConfig"
      :timestamp-config="timestampConfig"
      :link-options="linkOptions"
      @onMessageSubmit="onMessageSubmit"
      class="bordered-box full-pic__chat"
    />
  </div>
</template>

<script>
import { Chat } from 'vue-quick-chat'
import { mapGetters } from 'vuex'
import { GetChats, GetChatHistory, CreateChat } from '@/api/chat'
import { newAvatarS3Link } from "@/js/s3"
import moment from 'moment'

export default {
  name: 'MyChat',
  components: {
    Chat
  },

  props: {
    chatId: String,
    pictureId: String,
    picOwnerId: String,
    picOwnerName: String,
    picOwnerAvatar: String
  },

  computed: {
    ...mapGetters([
      'userID',
      'userFirstName',
      'userLastName',
      'userAvatar'
    ])
  },

  data() {
    return {
      chats: [],
      chatID: this.chatId,
      currentChat: {},
      ws: null,
      lastMessage: 1000 * 1000 * 10,
      ranOutOfMessagesOnBackend: false,
      stopScrolling: false,
      participants: [],
      myself: {},
      messages: [],
      placeholder: 'Send your message',
      colors: {
        header: {
          bg: 'rgba(247, 247, 247, 1)',
          text: '#zzzzzz'
        },
        message: {
          myself: {
            bg: '#fff',
            text: '#bdb8b8'
          },
          others: {
            bg: '#fb4141',
            text: '#fff'
          },
          messagesDisplay: {
            bg: '#f7f3f3'
          }
        },
        submitIcon: '#b91010',
        submitImageIcon: '#b91010'
      },
      submitIconSize: 25,
      submitImageIconSize: 25,
      toLoad: [],
      scrollBottom: {
        messageSent: true,
        messageReceived: false
      },
      profilePictureConfig: {
        others: true,
        myself: false,
        styles: {
          width: '40px',
          height: '40px',
          borderRadius: '50%'
        }
      },
      timestampConfig: {
        format: 'd MMM HH:mm',
        relative: false
      },
      linkOptions: {
        myself: {
          className: 'myLinkClass',
          events: {},
          format: function(value, type) {
            if (type === 'url' && value.length > 50) {
              value = value.slice(0, 50) + '…'
            }
            return value
          }
        },
        others: {
          className: 'othersLinkClass',
          events: {},
          format: function(value, type) {
            if (type === 'url' && value.length > 50) {
              value = value.slice(0, 50) + '…'
            }
            return value
          }
        }
      }
    }
  },

  methods: {
    addMoreMessages() {
      if (this.ranOutOfMessagesOnBackend) {
        return
      }

      if (!this.toLoad.length) {
        setTimeout(this.addMoreMessages, 500)
      } else {
        const chat = document.querySelector(".container-message-display")
        const initialScroll = chat.scrollHeight

        this.messages.unshift(...this.toLoad)
        this.$nextTick(() => {
          chat.scrollTop = chat.scrollHeight - initialScroll
        })
        this.toLoad = []
      }
    },

    async getMoreMessages(chatID) {
      const response = await GetChatHistory(chatID, this.lastMessage, 5)
      if (!response.status) {
        return
      }

      if (response.status !== 200) {
        this.$toasted.error('Oh no... Something bad happened')
        return
      }

      const messages = response.data.data.data.map(e => {
        const message = e.attributes
        return {
          id: e.id,
          content: message.message,
          myself: message.picture_owner_said === (this.userID === this.picOwnerId),
          type: 'text',
          timestamp: this.formatTimestamp(message.created_at),
          participantId: !(message.picture_owner_said === (this.userID === this.picOwnerId)) | 0
        }
      }).reverse()

      if (messages.length) {
        this.lastMessage = messages[0].id
      }

      return messages
    },

    async createChat() {
      const response = await CreateChat(this.pictureId)
      if (!response.status) {
        return
      }

      if (response.status !== 200) {
        this.$toasted.error('Oh no... Something bad happened')
        return
      }

      this.chatID = response.data.data.data.id
      this.initiateWS()
    },

    async changeChat(f) {
      this.lastMessage = 1000 * 1000 * 10
      this.chatID = f
      this.ranOutOfMessagesOnBackend = false

      const newUserChattingWith = this.chats.find(e => e.value === f)
      this.participants[1] = {
        name: newUserChattingWith.name,
        id: 1,
        profilePicture: newUserChattingWith.avatar
      }

      const messages = await this.getMoreMessages(f)
      this.$set(this, 'messages', messages)
      this.$set(this, 'toLoad', [])

      if (!this.ws) {
        this.initiateWS()
      }
    },

    initiateWS() {
      this.ws = new WebSocket("ws://api.friend-art.xyz/chat/chat")
      this.ws.onmessage = e => {
        const message = JSON.parse(e.data)

        if (parseInt(this.chatID) === message.chat_id) {
          this.messages.push({
            content: message.message,
            myself: false,
            type: 'text',
            timestamp: this.formatTimestamp(moment().format()),
            participantId: !(this.userID === this.picOwnerId) | 0
          })
        }
      }
      this.ws.onclose = () => {
        this.initiateWS()
      }
    },

    onMessageSubmit(message) {
      this.messages.push(message)
      this.ws.send(JSON.stringify({
        chat_id: parseInt(this.chatID),
        message: message.content
      }))
    },

    formatTimestamp(time) {
      const dateTime = time.split('T')
      const dateParts = dateTime[0].split('-')
      const hours = dateTime[1].split(':')[0]
      const minutes = dateTime[1].split(':')[1]

      return {
        month: parseInt(dateParts[1]),
        day: parseInt(dateParts[2]),
        hour: parseInt(hours),
        minute: parseInt(minutes)
      }
    }
  },

  async created() {
    this.myself = {
      name: this.userFirstName + ' ' + this.userLastName,
      id: 0,
      profilePicture: this.userAvatar
    }
    this.participants = [this.myself, {
      name: this.picOwnerName,
      id: 1,
      profilePicture: this.picOwnerAvatar
    }]

    if (this.picOwnerId === this.userID) {
      const response = await GetChats(this.$route.query.pictureID)
      if (!response.status) {
        return
      }

      if (response.status !== 200) {
        this.$toasted.error('Oh no... Something bad happened')
        return
      }

      const newChats = []
      response.data.data.data.forEach(e => {
        const chatID = e.id
        const userID = e.relationships.chatting_with.data.id
        const user = response.data.data.included.find(item => item.id === userID).attributes

        newChats.push({
          name: user.first_name + ' ' + user.last_name,
          value: chatID,
          avatar: user.has_avatar ? newAvatarS3Link(userID) : '/dummy.png'
        })
      })
      this.$set(this, 'chats', [...newChats])
    } else if (this.chatId) {
      const messages = await this.getMoreMessages(this.chatId)
      this.$set(this, 'toLoad', messages)

      this.initiateWS()
    }
  },

  watch: {
    async toLoad(val, prev) {
      if (!val.length && !this.ranOutOfMessagesOnBackend) {
        this.page++
        const newMessages = await this.getMoreMessages(this.chatID)
        if (!newMessages.length) {
          this.ranOutOfMessagesOnBackend = true
        }
        this.$set(this, 'toLoad', newMessages)
      }
    }
  }
}
</script>

<style>
.container-message-manager {
  display: flex;
  margin: 5px;
}

.quick-chat-container {
  padding: 5px 5px 0 5px;
}

.container-message-display {
  display: grid;
  max-height: 50vh;
  overflow: auto;
  background-color: rgba(51, 51, 51, 0.2) !important;
  border-radius: 10px;
}

.message-text-box {
  width: 100%;
  background-color: white;
  border-radius: 10px;
  border-style: groove;
  border-width: 1px;
  border-color: rgba(51, 51, 51, 0.3);
  padding-left: 10px;
  padding-top: 6px;
}

.message-input:focus {
  outline: none;
  font-family: "Lucida Sans Unicode",sans-serif;
  font-size: 14px;
  font-weight: 500;
  line-height: 15px;
}

.full-pic__chat {
  margin-left: 20%;
  margin-right: 20%;
}

.message-container {
  padding: 10px;
}

.myself-message-body {
  float: right;
}

.other-message-body {
  float: left;
}

.message-text {
  max-width: 40vh;
  padding: 8px;
  white-space: pre-line !important;
  word-break: break-word;
  font-family: "Lucida Sans Unicode",sans-serif;
  font-size: 17px;
  font-weight: 400;
  line-height: 15px;
  border-radius: 15px;
}

.myself-message-body .message-text {
  color: rgba(0, 0, 0, 0.8) !important;
}

.message-timestamp {
  color: rgba(51, 51, 51, 1);
  font-family: 'Nunito', fantasy;
  font-style: normal;
  font-weight: 400;
  font-size: 13px;
  letter-spacing: .03em;
}

.message-username {
  font-weight: 600;
}

.myself-message-body .message-timestamp, .myself-message-body .thum-container {
  float: right;
}

.chat-select {
  display: grid;
  place-content: center;
  margin-top: 40px;
}

.v-select__slot label {
  margin-top: 1px;
}

.chat-select .v-input__control {
  min-width: 300px;
}

.message-text p {
  margin-top: 2px;
}

</style>
